#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <limits.h>

#include "main.h"
#include "edit.h"
#include "textgrph.h"
#include "files.h"
#include "menus.h"
#include "help.h"


// ***************** GETLINE function *******************
#define MAX_KEYS  30

static short norm_color_fg;
static short norm_color_bg;
static short high_color_fg;
static short high_color_bg;
static short undr_color_fg;
static short undr_color_bg;
static short ins_color_fg;
static short ins_color_bg;
static short st_col, end_col;
static short length;
static short row, col;
static short st_row;
static short ins_row;
static short ins_col;
static char stop_key;

static char VALID_EXIT_KEYS[MAX_KEYS];

char GetLine(short option, char cParm1, short iParm1, short iParm2, short iParm3,
             short iParm4, char *char_ptr)
{
  short ctr;
  char last_key;
  
  VALID_EXIT_KEYS[29] = '\0';
  
  CursorOn();
  switch(option)
  {
    case 0:   // Set default parameters
              norm_color_fg = WHITE;
              norm_color_bg = BLACK;
              high_color_fg = BRIGHTWHITE;
              high_color_bg = BLACK;
              stop_key = CR_KEY;
              undr_color_fg = GREEN;
              undr_color_bg = BLACK;
              ins_color_fg = YELLOW;
              ins_color_bg = BLACK;
              ins_row = 24;
              ins_col = 70;
              break;
    case 1:   // Set colors
              norm_color_fg = iParm1;
              norm_color_bg = iParm2;
              high_color_fg = iParm3;
              high_color_bg = iParm4;
              break;
    case 2:   // Insert normal and high colors
              undr_color_fg = iParm1;
              undr_color_bg = iParm2;
              break;
    case 3:   ins_color_fg = iParm1;
              ins_color_bg = iParm2;
              ins_row = iParm4;
              ins_col = iParm3;
              break;
    case 4:   break;
    case 5:   break;
    case 6:   row = st_row = iParm2;
              col = st_col = iParm1;
              end_col = st_col + iParm4;
              length = iParm4;
              last_key = GetIt(option, char_ptr);
              break;
    case 7:   row = st_row = iParm2;
              col = st_col = iParm1;
              end_col = st_col + iParm4;
              length = iParm4;
              last_key = GetIt(option, char_ptr);
              break;
    case 8:   for(ctr = 0; ctr < iParm1; ctr++)
                char_ptr[ctr] = '\0';
              break;
    case 9:   SetupExitKeys(char_ptr, iParm1);
              break;
  }
  CursorOff();
  return last_key;
}


char GetIt(short option, char *str_ptr)
{
  short ch;
  short str_ctr = 0;
  short ins_on = FALSE;
  short prn_switch = FALSE;
  short loop_exit = FALSE;
  
  Cursor(st_col, st_row);
  RepeatChar('_', length, undr_color_fg, undr_color_bg);
  WriteString(norm_color_fg, norm_color_bg, st_col, st_row, "%s", str_ptr);
  Cursor(st_col, st_row);
  
  while(loop_exit == FALSE)
  {
    if((ch = getch()) == 0) // if scan code read next byte
    {
      ch = getch();
      switch(ch)
      {
        case HOME:   // goto begining of string
                     col = st_col;
                     Cursor(col, row);
                     if(ins_on == TRUE)
                       WriteString(norm_color_fg, norm_color_bg, st_col,
                                   st_row, "%s", str_ptr);
                     break;
       case END:     // pos cursor at end
                     col = strlen(str_ptr) + st_col;
                     Cursor(col, row);
                     if(ins_on == TRUE)
                       WriteString(norm_color_fg, norm_color_bg, st_col,
                                   st_row, "%s", str_ptr);
                     break;
       case DEL:     if(col != (short)strlen(str_ptr) + st_col)
                     {
                       needSaved = TRUE;
                       
                       // save current position
                       str_ctr = col;
                       // if next pos is != null move it
                       while(str_ptr[col-st_col+1] != '\0')
                       {
                         str_ptr[col-st_col] = str_ptr[col-st_col+1];
                         col++;
                       }
                       str_ptr[col-st_col] = '\0';
                       WriteString(norm_color_fg, norm_color_bg, st_col,
                                   st_row, "%s", str_ptr);
                       Cursor(st_col+strlen(str_ptr), row);
                       WriteChar('_', undr_color_fg, undr_color_bg);
                       col = str_ctr;
                       Cursor(col, row);
                     }
                     if(ins_on == TRUE)
                       WriteString(norm_color_fg, norm_color_fg, st_col,
                                   st_row, "%s", str_ptr);
                     break;
       case INS:     if(ins_on == FALSE)
                     {
                       WriteString(ins_color_fg, ins_color_bg, ins_col,
                                   ins_row, "INS");
                       Cursor(col, row);
                       ins_on = TRUE;
                     } else
                     {
                       WriteString(ins_color_fg, ins_color_bg, ins_col,
                                   ins_row, "   ");
                       Cursor(col, row);
                       ins_on = FALSE;
                     }
                     break;
       case LT_ARROW: if(col > st_col)
                      {
                        Cursor(--col, row);
                        if(ins_on == TRUE)
                          WriteString(norm_color_fg, norm_color_bg, st_col,
                                      st_row, "%s", str_ptr);
                      }
                      break;
       case RT_ARROW: if(col < end_col && ((col-st_col) < (short)strlen(str_ptr)))
                      {
                        Cursor(++col, row);
                        if(ins_on == TRUE)
                          WriteString(norm_color_fg, norm_color_bg, st_col,
                                      st_row, "%s", str_ptr);
                      }
                      break;
       default:       loop_exit = CheckList((char)ch);
                      if(ins_on == TRUE)
                        WriteString(norm_color_fg, norm_color_bg, st_col,
                                    st_row, "%s", str_ptr);
                      if(loop_exit == FALSE)
                        Boop();
                      break;
      }
    } else
    {
      switch(ch) // test for other special keys
      {
        case BK_SP_KEY:  if(col > st_col)
                         {
                           needSaved = TRUE;
                           
                           Cursor(--col, row);
                           str_ctr = col;
                           while(str_ptr[col-st_col+1] != '\0')
                           {
                             str_ptr[col-st_col] = str_ptr[col-st_col+1];
                             col++;
                           }
                           str_ptr[col-st_col] = '\0';
                           WriteString(norm_color_fg, norm_color_bg, st_col,
                                       st_row, "%s", str_ptr);
                           Cursor(st_col+strlen(str_ptr), row);
                           WriteChar('_', undr_color_fg, undr_color_bg);
                           col = str_ctr;
                           Cursor(col, row);
                         }
                         break;
        default:         if(col < end_col)
                         {
                           if(option == 7 && ((ch >= 48 && ch <= 57) ||
                              ch == '.' || ch == '-'))
                           {
                             prn_switch = TRUE;
                           }
                           if(option == 6 && ch > 31)
                           {
                             prn_switch = TRUE;
                           }
                           if(prn_switch == TRUE)
                           {
                             if(ins_on == TRUE && (short)strlen(str_ptr) < length)
                             {
                               // assign str_ctr to the cur location
                               str_ctr = strlen(str_ptr);
                               while(str_ctr != col-st_col)
                               {
                                 str_ptr[str_ctr] = str_ptr[str_ctr-1];
                                 str_ctr--;
                               }
                               needSaved = TRUE;
                               
                               str_ptr[col-st_col] = (char)ch;
                               WriteString(norm_color_fg, norm_color_bg,
                                           st_col, st_row, "%s", str_ptr);
                               WriteChar((char)ch, high_color_fg,
                                                   high_color_bg);
                               Cursor(++col, row);
                               prn_switch = FALSE;
                             } else
                             {
                               // INS off put a char
                               if(ins_on == FALSE)
                               {
                                 needSaved = TRUE;
                                 
                                 str_ptr[col-st_col] = (char)ch;
                                 WriteString(norm_color_fg, norm_color_bg,
                                            st_col, st_row, "%s", str_ptr);
                                 Cursor(++col, row);
                                 prn_switch = FALSE;
                               } else
                               {
                                 // ins_on is TRUE and trying to put a char
                                 // past end
                                 Boop();
                               }
                             }
                           } else
                           {
                             if((loop_exit = CheckList((char)ch)) == FALSE)
                             {
                               // Not a valid exit key
                               Boop();
                             } else
                             {
                               WriteString(norm_color_fg, norm_color_bg,
                                          st_col, st_row, "%s", str_ptr);
                             }
                           }
                         } else
                         {
                           // exit key?
                           if((loop_exit = CheckList((char)ch)) == FALSE)
                           {
                             // not a valid exti key
                             Boop();
                           } else
                           {
                             WriteString(norm_color_fg, norm_color_bg,
                                         st_col, st_row, "%s", str_ptr);
                           }
                         }
                         break;
      }
    }
  }
  
  return (char)ch;
}                           


short CheckList(char key_pressed)
{
  short return_code = FALSE;
  short loop_ctr = 0;
  
  while(loop_ctr <= MAX_KEYS && !return_code)
    if(key_pressed == VALID_EXIT_KEYS[loop_ctr++])
      return_code = TRUE;
  return return_code;
}


void SetupExitKeys(char *keys_array, short num)
{
  short ctr;
  
  for(ctr = 0; ctr < num; ctr++)
  {
    VALID_EXIT_KEYS[ctr] = *(keys_array+ctr);
  }
  
  while(ctr < MAX_KEYS)
  {
    VALID_EXIT_KEYS[ctr++] = '\0';
  }
}


void WaitSec(double secs)
{
  unsigned long count0, count;
  
  count0 = GetTimerTicks();
  count = (unsigned long)(count0 + secs * 18.2);
  while(GetTimerTicks() < count);
}


void Boop(void)
{
  unsigned char port0;
  unsigned short div0 = DIV0*2;
  double delay = CLICK;
  short result;
  
  result = _outp(T_MODEPORT, SPKRMODE);
  port0 = _inp(SPKRPORT);
  
  result = _outp(FREQPORT, (div0 & 0xFF));
  result = _outp(FREQPORT, (div0 >> 8));
  result = _outp(SPKRPORT, (port0 | SPKRON));
  
  WaitSec(delay);
  result = _outp(SPKRPORT, port0);
}


void MainMenu(void)
{
  short key;
  short done = FALSE;
  
  CursorOff();
  
  while(!done)
  {
    Cursor(0, 0);
    RepeatChar(' ', 80, BRIGHTWHITE, BLUE);
    WriteString(BRIGHTWHITE, BLUE, 36, 0, "DATABASE");
    Grid(0, 1, 79, 24, CYAN, BLACK, 1);
  
    Grid(30, 11, 54, 15, GRAY, BLACK, 1);
    Box(28, 10, 52, 14, DOUBLE_BOX, 1, YELLOW, GREEN);
    
    WriteString(YELLOW, GREEN, 30, 11, "1) Make New Database");
    WriteString(YELLOW, GREEN, 30, 12, "2) Open Old Database");
    WriteString(YELLOW, GREEN, 30, 13, "3) Quit");
  
    key = GetKey(WAIT);
    
    switch(LOBYTE(key))
    {
      case 0:
      case 0xE0: if(HIBYTE(key) == 59) /* F1 */
                 {
                   HelpMainScreen(BEGIN_MENU);
                   CursorOff();
                 }
                 break;
      case '1':  if(MakeNewDatabase())
                 {
                   done = EditDatabase();
                   CursorOff();
                 }
                 break;
      case '2':  if(OpenOldDatabase())
                 {
                   done = EditDatabase();
                   CursorOff();
                 } else
                 {
                   CursorOff();
                 }                 
                 break;
      case '3':  done = TRUE;
                 break;
      default:   Boop();
                 break;
    }
  }

  CursorOn();
}


short MakeNewDatabase(void)
{
  short ret = TRUE;
  char exitKeys[] = { ESC_KEY, CR_KEY, ENTER_KEY };
  short i;
  char *cp;
  short gotName = FALSE;
  
  ClearScreen(WHITE, BLACK);
  Cursor(0, 0);
  
  ClearFields();
  
  numFields = 0;
  while(numFields < 1 || numFields > 100)
  {
    numFields = atoi(InputBox(10, 10, 3, "Number of fields [1-100]:"));
  }
  
  WriteString(BRIGHTWHITE, BLACK, 0, 0, "Field Types:");
  WriteString(BRIGHTWHITE, BLACK, 2, 1, "1) STRING              2) CHARACTER");
  WriteString(BRIGHTWHITE, BLACK, 2, 2, "3) UNSIGNED CHARACTER  4) INTEGER");
  WriteString(BRIGHTWHITE, BLACK, 2, 3, "5) UNSIGNED INTEGER    6) LONG");
  WriteString(BRIGHTWHITE, BLACK, 2, 4, "7) UNSIGNED LONG       8) DOUBLE");
  
  for(i = 0; i < numFields; i++)
  {
    strcpy(fieldNames[i], InputBox(10, 10, 20, "Field #%d Name:" , i+1));
    fieldInfo[i][F_TYPE] = 0;
    while(fieldInfo[i][F_TYPE] < STRING || fieldInfo[i][F_TYPE] > DOUBLE)
    {
      fieldInfo[i][F_TYPE] = atoi(InputBox(10, 10, 1, "Field #%d Type:", i+1));
    }
    if(fieldInfo[i][F_TYPE] == STRING)
    {
      fieldInfo[i][F_LENGTH] = 0;
      while(fieldInfo[i][F_LENGTH] < 1 || fieldInfo[i][F_LENGTH] > 50)
      {
        fieldInfo[i][F_LENGTH] = atoi(InputBox(10, 10, 2,
                                      "Field #%d Length [1-50]:", i+1));
      }
    } else
    {
      switch(fieldInfo[i][F_TYPE])
      {
        case CHARACTER:
        case UNSIGNED_CHARACTER: fieldInfo[i][F_LENGTH] = 4; break;
        case INTEGER:
        case UNSIGNED_INTEGER: fieldInfo[i][F_LENGTH] = 6; break;
        case LONG:
        case UNSIGNED_LONG: fieldInfo[i][F_LENGTH] = 11; break;
        case DOUBLE: fieldInfo[i][F_LENGTH] = 50; break;
      }
    }
  }
  
  while(!gotName)
  {
    strcpy(filename, InputBox(0, 10, 60, "Filename:"));
    cp = strchr(filename, '.');
    if(cp)
    {
      cp++;
      *cp++ = 'D';
      *cp++ = 'B';
      *cp++ = 'S';
      *cp = 0;
    } else
    {
      strcat(filename, ".DBS");
    } 
    
    if(FileExist(filename))
    {
      gotName = YesNoBox("%s exists. Overwrite?", filename);
    } else if(!FileExist(filename) && (cp = strchr(filename, ' ')) == NULL)
    {
      gotName = TRUE;
    } else if((cp = strchr(filename, ' ')) != NULL)
    {
      MessageBox("Your filename cannot contain spaces.");
    }
  }
  
  recordLength = CalcRecordLength(); 
  OpenNewFile(filename);
    
  return ret;
}


short OpenOldDatabase(void)
{
  short ret = TRUE;
  
  strcpy(filename, GetFile("*.DBS&"));
  
  if(filename[0] == 0)
  {
    ret = FALSE;
  } else
  {
    if(OpenOldFile(filename))
    {
      ret = TRUE;
    } else
    {
      ret = FALSE;
    }
  }
  return ret;
}


short EditDatabase(void)
{
  char *screenBuffer;
  short ret = FALSE;
  short done = FALSE;
  short yPos = 0;
  short yStart = 0;
  short lastVisLine;
  short maxYStart;
  char exitKeys[] = {ESC_KEY, CR_KEY, PAGE_UP, PAGE_DN, UP_ARROW, DN_ARROW,
                     ENTER_KEY, SHIFT_TAB, TAB_KEY, F1, F2, F3, F4, F10};
  char rv;
  short ar;
  
  curRecord = 0;
    
  maxYStart = numFields - 20;
  if(maxYStart < 0)
  {
    maxYStart = 0;
  }
  
  lastVisLine = numFields - yStart - 1;
  if(lastVisLine > 20)
  {
    lastVisLine = 20;
  }
  
  GetLine(SET_EXIT_KEYS, 0, 14, 0, 0, 0, exitKeys);
  GetLine(SET_NORMAL, 0, BRIGHTWHITE, BLUE, BRIGHTWHITE, BLUE, 0);
  GetLine(SET_UNDERLINE, 0, BRIGHTWHITE, BLUE, 0, 0, 0);
  GetLine(SET_INS, 0, BLACK, CYAN, 77, 24, 0);
  
  DrawEditScreen();
  WriteFieldData(yStart, 0, lastVisLine);
  
  needSaved = FALSE;
  
  while(!done)
  {
    if(fieldInfo[yPos+yStart][F_TYPE] == STRING)
    {
      rv = GetLine(GET_ALPHA, 0, 3+strlen(fieldNames[yPos+yStart]), yPos+2,
                0, fieldInfo[yPos+yStart][F_LENGTH], fieldData[yPos+yStart]);
    } else 
    {
      rv = GetLine(GET_NUM, 0, 3+strlen(fieldNames[yPos+yStart]), yPos+2,
                0, fieldInfo[yPos+yStart][F_LENGTH], fieldData[yPos+yStart]);
    }
  
    switch(rv)
    {
      case ENTER_KEY:
      case CR_KEY:
      case DN_ARROW:
      case TAB_KEY:  if(yPos < 20 && yPos < (numFields - 1))
                     {
                       yPos++;
                     } else
                     {
                       if(yStart < maxYStart)
                       {
                         yStart++;
                       } else
                       {
                         MessageBox("This is the last field.");
                       }
                     }
                     lastVisLine = numFields - yStart - 1;
                     if(lastVisLine > 20)
                     {
                       lastVisLine = 20;
                     }
                     WriteFieldData(yStart, 0, lastVisLine);
                     break;
      case SHIFT_TAB:
      case UP_ARROW: if(yPos > 0)
                     {
                       yPos--;
                     } else
                     {
                       if(yStart > 0)
                       {
                         yStart--;
                       } else
                       {
                         MessageBox("This is the first field.");
                       }
                     }
                     lastVisLine = numFields - yStart - 1;
                     if(lastVisLine > 20)
                     {                
                       lastVisLine = 20;
                     }
                     WriteFieldData(yStart, 0, lastVisLine);
                     break;
      case F1: HelpMainScreen(GENERAL);
               break;
      case F2: WriteRecord(dfile, curRecord+1);
               MessageBox("Record saved.");
               needSaved = FALSE;
               break;
      case F3: MessageBox("Search not complete.");
               break;
      case F4: if(needSaved == TRUE)
               {
                 if(YesNoBox("Record not saved. Save it?"))
                 {
                   WriteRecord(dfile, curRecord+1);
                 }
               }
               needSaved = FALSE;
               if(numRecords < 32767)
               {
                 numRecords++;
                 curRecord = numRecords - 1;
                 fseek(dfile, 2L, SEEK_SET);
                 if(fwrite(&numRecords, sizeof(short), 1, dfile) != 1)
                 {
                   MessageBox("Error writing to disk!");
                 }
                 ClearFields();
                 WriteRecord(dfile, curRecord+1);
                 yPos = 0;
                 yStart = 0;
                 lastVisLine = numFields - yStart - 1;
                 if(lastVisLine > 21)
                 {                
                   lastVisLine = 21;
                 }
                 WriteFieldData(yStart, 0, lastVisLine);
                 MessageBox("New record added.");
               } else
               {
                 MessageBox("There can only be 32767 records maximum.");
               }
               break;  
      case F10: ar = DoActionBar();
                switch(ar)
                {
                  case 1:  /* Save */
                           WriteRecord(dfile, curRecord+1);
                           MessageBox("Record saved.");
                           needSaved = FALSE;
                           break;
                  case 2:  /* Main Menu */
                           if(needSaved == TRUE)
                           {
                             if(YesNoBox("Record not saved. Save it?"))
                             {
                               WriteRecord(dfile, curRecord+1);
                               needSaved = FALSE;
                             }
                           }
                           if(YesNoBox("Quit?"))
                           {
                             done = TRUE;
                           }
                           break;
                  case 3:  /* DOS Shell */
                           screenBuffer = SaveScreenArea(0, 0, 79, 24);
                           ClearScreen(WHITE, BLACK);
                           Cursor(0, 0);
                           system("C:\\COMMAND.COM");
                           RestoreScreenArea(screenBuffer);
                           break;
                  case 4:  /* Quit */
                           if(needSaved == TRUE)
                           {
                             if(YesNoBox("Record not saved. Save it?"))
                             {
                               WriteRecord(dfile, curRecord+1);
                               needSaved = FALSE;
                             }
                           }
                           if(YesNoBox("Quit?"))
                           {
                             done = TRUE;
                             ret = TRUE;
                           }
                           break;
                  case 10: /* Clear Field */
                           if(YesNoBox("Erase this field?"))
                           {
                             memset(fieldData[yPos+yStart], 0, 51);
                             WriteFieldData(yStart, 0, lastVisLine);
                           }
                           break;
                  case 11: /* Clear Record */
                           if(YesNoBox("Clear record?"))
                           {
                             ClearFields();
                             WriteFieldData(yStart, 0, lastVisLine);
                           }
                           break;
                  case 12: /* Search */
                           MessageBox("Search not complete.");
                           break;
                  case 20: /* New Record */
                           if(needSaved == TRUE)
                           {
                             if(YesNoBox("Record not saved. Save it?"))
                             {
                               WriteRecord(dfile, curRecord+1);
                             }
                           }
                           needSaved = FALSE;
                           if(numRecords < 32767)
                           {
                             numRecords++;
                             curRecord = numRecords - 1;
                             fseek(dfile, 2L, SEEK_SET);
                             if(fwrite(&numRecords, sizeof(short), 1, dfile) != 1)
                             {
                               MessageBox("Error writing to disk!");
                             }
                             ClearFields();
                             WriteRecord(dfile, curRecord+1);
                             yPos = 0;   
                             yStart = 0;
                             lastVisLine = numFields - yStart - 1;
                             if(lastVisLine > 20)
                             {                
                               lastVisLine = 20;
                             }
                             WriteFieldData(yStart, 0, lastVisLine);
                             MessageBox("New record added.");
                           } else
                           {
                             MessageBox("There can only be 32767 records maximum.");
                           }
                           break;
                  case 21: /* Delete Record */
                           MessageBox("Can't delete records yet.");
                           break;
                  case 22: /* Next Record */
                           if(needSaved == TRUE)
                           {
                             if(YesNoBox("Record not saved. Save it?"))
                             {
                               WriteRecord(dfile, curRecord+1);
                             }
                           }
                           needSaved = FALSE;
                           if(curRecord < (numRecords-1))
                           {
                             curRecord++;
                             ReadRecord(dfile, curRecord+1);
                             yPos = 0;
                             yStart = 0;
                             lastVisLine = numFields - yStart - 1;
                             if(lastVisLine > 20)
                             {                
                               lastVisLine = 20;
                             }
                             WriteFieldData(yStart, 0, lastVisLine);
                           } else
                           {
                             MessageBox("This is the last record.");
                           }
                           break;
                  case 23: /* Previous Record */
                           if(needSaved == TRUE)
                           {
                             if(YesNoBox("Record not saved. Save it?"))
                             {
                               WriteRecord(dfile, curRecord+1);
                             }
                           }
                           needSaved = FALSE;
                           if(curRecord > 0)
                           {
                             curRecord--;
                             ReadRecord(dfile, curRecord+1);
                             yPos = 0;
                             yStart = 0;
                             lastVisLine = numFields - yStart - 1;
                             if(lastVisLine > 20)
                             {                
                               lastVisLine = 20;
                             }
                             WriteFieldData(yStart, 0, lastVisLine);
                           } else
                           {
                             MessageBox("This is the first record.");
                           }
                           break;
                  case 30: /* Create Report */
                           MessageBox("Reporting not done yet.");
                           break;
                  case 40: /* Main Help */
                           HelpMainScreen(GENERAL);
                           break;
                  case 41: /* About */
                           MessageBox(" DATABASE version 1.00 (c) 1997  By:"
                                      " Patrick Barry");
                           break;
                }
                break;
      case PAGE_DN: if(needSaved == TRUE)
                    {
                      if(YesNoBox("Record not saved. Save it?"))
                      {
                        WriteRecord(dfile, curRecord+1);
                      }
                    }
                    needSaved = FALSE;
                    if(curRecord > 0)
                    {
                      curRecord--;
                      ReadRecord(dfile, curRecord+1);
                      yPos = 0;
                      yStart = 0;
                      lastVisLine = numFields - yStart - 1;
                      if(lastVisLine > 20)
                      {                
                        lastVisLine = 20;
                      }
                      WriteFieldData(yStart, 0, lastVisLine);
                    } else
                    {
                      MessageBox("This is the first record.");
                    }                    
                    break;
      case PAGE_UP: if(needSaved == TRUE)
                    {
                      if(YesNoBox("Record not saved. Save it?"))
                      {
                        WriteRecord(dfile, curRecord+1);
                      }
                    }
                    needSaved = FALSE;
                    if(curRecord < (numRecords-1))
                    {
                      curRecord++;
                      ReadRecord(dfile, curRecord+1);
                      yPos = 0;
                      yStart = 0;
                      lastVisLine = numFields - yStart - 1;
                      if(lastVisLine > 20)
                      {                
                        lastVisLine = 20;
                      }
                      WriteFieldData(yStart, 0, lastVisLine);
                    } else
                    {
                      MessageBox("This is the last record.");
                    }
                    break;
    }
  }
  
  return ret;
}


char StrToChar(char *string)
{
  char *cp;
  short len;
  short count = 1;
  double total = 0;
  short sign = 1;
  
  cp = strchr(string, '.');
  if(!cp)
  {
    len = strlen(string);
    cp += len;
  }
  
  while(cp >= string)
  {
    if(*cp = '-')
    {
      sign = -1;
      cp--;
    } else if(*cp >= '0' && *cp <= '9')
    {
      total += (*cp - 48) * count;
      count *= 10;
      cp--;
    } else
    {
      return 0;
    }
  }

  total *= sign;
  
  if(total < SCHAR_MIN)
  {
    total = SCHAR_MIN;
  } else if(total > SCHAR_MAX)
  {
    total = SCHAR_MAX;
  }
  
  return (char)total;
}


unsigned char StrToUnChar(char *string)
{
  char *cp;
  short len;
  short count = 1;
  double total = 0;
    
  cp = strchr(string, '.');
  if(!cp)
  {
    len = strlen(string);
    cp += len;
  }
  
  while(cp >= string)
  {
    if(*cp = '-')
    {
      // ignore the sign
      cp--;
    } else if(*cp >= '0' && *cp <= '9')
    {
      total += (*cp - 48) * count;
      count *= 10;
      cp--;
    } else
    {
      return 0;
    }
  }

  if(total > UCHAR_MAX)
  {
    total = UCHAR_MAX;
  }
  
  return (unsigned char)total;
}


short StrToInt(char *string)
{
  char *cp;
  short len;
  short count = 1;
  double total = 0;
  short sign = 1;
  
  cp = strchr(string, '.');
  if(!cp)
  {
    len = strlen(string);
    cp += len;
  }
  
  while(cp >= string)
  {
    if(*cp = '-')
    {
      sign = -1;
      cp--;
    } else if(*cp >= '0' && *cp <= '9')
    {
      total += (*cp - 48) * count;
      count *= 10;
      cp--;
    } else
    {
      return 0;
    }
  }

  total *= sign;
  
  if(total < SHRT_MIN)
  {
    total = SHRT_MIN;
  } else if(total > SHRT_MAX)
  {
    total = SHRT_MAX;
  }
  
  return (short)total;
}


unsigned short StrToUnInt(char *string)
{
  char *cp;
  short len;
  short count = 1;
  double total = 0;
    
  cp = strchr(string, '.');
  if(!cp)
  {
    len = strlen(string);
    cp += len;
  }
  
  while(cp >= string)
  {
    if(*cp = '-')
    {
      // ignore the sign
      cp--;
    } else if(*cp >= '0' && *cp <= '9')
    {
      total += (*cp - 48) * count;
      count *= 10;
      cp--;
    } else
    {
      return 0;
    }
  }

  if(total > USHRT_MAX)
  {
    total = USHRT_MAX;
  }
  
  return (unsigned short)total;
}


long StrToLong(char *string)
{
  char *cp;
  short len;
  short count = 1;
  double total = 0;
  short sign = 1;
  
  cp = strchr(string, '.');
  if(!cp)
  {
    len = strlen(string);
    cp += len;
  }
  
  while(cp >= string)
  {
    if(*cp = '-')
    {
      sign = -1;
      cp--;
    } else if(*cp >= '0' && *cp <= '9')
    {
      total += (*cp - 48) * count;
      count *= 10;
      cp--;
    } else
    {
      return 0;
    }
  }

  total *= sign;
  
  if(total < LONG_MIN)
  {
    total = LONG_MIN;
  } else if(total > LONG_MAX)
  {
    total = LONG_MAX;
  }
  
  return (long)total;
}


unsigned long StrToUnLong(char *string)
{
  char *cp;
  short len;
  short count = 1;
  double total = 0;
    
  cp = strchr(string, '.');
  if(!cp)
  {
    len = strlen(string);
    cp += len;
  }
  
  while(cp >= string)
  {
    if(*cp = '-')
    {
      // ignore the sign
      cp--;
    } else if(*cp >= '0' && *cp <= '9')
    {
      total += (*cp - 48) * count;
      count *= 10;
      cp--;
    } else
    {
      return 0;
    }
  }

  if(total > ULONG_MAX)
  {
    total = ULONG_MAX;
  }
  
  return (unsigned long)total;
}


double StrToDouble(char *string)
{
  if(string[0] == 0)
  {
    return 0;
  } else
  {
    return atof(string);
  }
}


char *InputBox(short x, short y, short inLen, char *message, ...)
{
  char *screenBuffer;
  char buffer[81];
  short x2, y2;
  char temp[120];
  va_list args;
  char exitKeys[] = { ESC_KEY, CR_KEY, ENTER_KEY };
  char ch;
    
  va_start(args, message);
  vsprintf(temp, message, args);
  va_end(args);
  
  x2 = x + strlen(temp) + 4 + inLen;
  y2 = y + 2;
  
  screenBuffer = SaveScreenArea(x, y, x2+2, y2+1);
  
  Grid(x+2, y+1, x2+2, y2+1, GRAY, BLACK, 1);
  Box(x, y, x2, y2, SINGLE_BOX, 1, BRIGHTWHITE, CYAN);
  WriteString(BRIGHTWHITE, CYAN, x+2, y+1, "%s ", temp);
  
  GetLine(SET_EXIT_KEYS, 0, 3, 0, 0, 0, exitKeys);
  GetLine(CLEAR_FIELD, 0, 81, 0, 0, 0, buffer);
  GetLine(SET_NORMAL, 0, BRIGHTWHITE, CYAN, BRIGHTWHITE, CYAN, 0);
  GetLine(SET_UNDERLINE, 0, BRIGHTWHITE, CYAN, 0, 0, 0);
  
  CursorOn();
  ch = GetLine(GET_ALPHA, 0, x + strlen(temp) + 3, y+1, 0, inLen, buffer);
  CursorOff();
  
  if(ch == ESC_KEY)
  {
    strcpy(buffer, "\0");
  }
    
  RestoreScreenArea(screenBuffer);
  return buffer;
}


void DrawEditScreen(void)
{
  Cursor(0, 0);
  RepeatChar(' ', 80, BLACK, WHITE);
  WriteString(BLACK, WHITE, 3, 0, "File   Edit   Record   Report   Help");
  WriteString(BLACK, WHITE, 60, 0, "<F10=MENU BAR>");
  Box(0, 1, 79, 23, DOUBLE_BOX, 1, BRIGHTWHITE, BLUE);
  Cursor(0, 24);
  RepeatChar(' ', 80, BLACK, CYAN);
}


void WriteFieldData(short off, short start, short end)
{
  short i;
  
  for(i = start; i <= end; i++)
  {
    Cursor(1, i+2);
    RepeatChar(' ', 78, BRIGHTWHITE, BLUE);
    WriteString(BRIGHTWHITE, BLUE, 1, i+2, "%s:", fieldNames[i+off]);
    Cursor(3+strlen(fieldNames[i+off]), i+2);
    RepeatChar('_', fieldInfo[i+off][F_LENGTH], BRIGHTWHITE, BLUE);
    WriteString(BRIGHTWHITE, BLUE, 3+strlen(fieldNames[i+off]), i+2,
                "%s", fieldData[i]);
  }
  
  WriteString(BLACK, CYAN, 2, 24, "Current Record #%d         ", curRecord+1);
}