#ifndef _EDIT_H
#define _EDIT_H

#define BLANK         ' '
#define SPACE         ' '
#define NEWLINE       '\n'
#define TAB           '\t'

#define EOS            0
#define YES            1
#define NO             0
#define TRUE           1
#define FALSE          0

#define CR             13
#define LF             10
#define EOL            13

#define CLR_INS        1
#define NO_CLR         0

#define CTR_STR        1
#define NO_CTR_STR     0

// ******* Keys ********
// numeric keypad scan codes
#define HOME              71
#define UP_ARROW          72
#define PAGE_UP           73
#define LT_ARROW          75
#define RT_ARROW          77
#define END               79
#define DN_ARROW          80
#define PAGE_DN           81
#define INS               82
#define DEL               83
#define SHIFT_TAB         15
#define ENTER_KEY         28

// function keys
#define F1                59
#define F2                60
#define F3                61
#define F4                62
#define F5                63
#define F6                64
#define F7                65
#define F8                66
#define F9                67
#define F10               68

// Other non scan keys as ASCII
#define BK_SP_KEY         8
#define ESC_KEY           27
#define CR_KEY            13
#define TAB_KEY           9
#define SPACE_BAR         32

// GETLINE options
#define SET_DEFAULTS      0
#define SET_NORMAL        1
#define SET_UNDERLINE     2
#define SET_INS           3
#define GET_ALPHA         6
#define GET_NUM           7
#define CLEAR_FIELD       8
#define SET_EXIT_KEYS     9

// SOUND STUFF
#define CLOCKFREQ         1193180L
#define SPKRMODE          0xB6
#define T_MODEPORT        0x43
#define FREQPORT          0x42
#define FREQ0             0x12c
#define DIV0              CLOCKFREQ /  FREQ0
#define CLICK             .15
#define SPKRPORT          0x61
#define SPKRON            0x03

char GetLine(short option, char cParm1, short iParm1, short iParm2, short iParm3,
             short iParm4, char *char_ptr);
char GetIt(short option, char *str_ptr);
short CheckList(char key_pressed);
void SetupExitKeys(char *keys_array, short num);
void WaitSec(double secs);
void Boop(void);

void MainMenu(void);
short MakeNewDatabase(void);
short OpenOldDatabase(void);
short EditDatabase(void);
char StrToChar(char *string);
unsigned char StrToUnChar(char *string);
short StrToInt(char *string);
unsigned short StrToUnInt(char *string);
long StrToLong(char *string);
unsigned long StrToUnLong(char *string);
double StrToDouble(char *string);
char *InputBox(short x, short y, short inLen, char *message, ...);
void DrawEditScreen(void);
void WriteFieldData(short off, short start, short end);


#endif

