#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <dos.h>
#include <direct.h>
#include <string.h>

#include "main.h"
#include "files.h"
#include "menus.h"
#include "edit.h"
#include "textgrph.h"
#include "help.h"


FILE *dfile;
char filename[129];



char *GetFile(char *extensions)
{
  struct _find_t fInfo;
  int i = 0;
  int cnt;
  int maxOffset;
  int yOffset = 0;
  char names[1024][16];
  char backup[256];
  int subloop = 1;
  int key;
  int j;
  int curY = 0;
  char findExt[6];
  char *cp;
  
  CursorOff();
  
Top:
  i = 0;
  strcpy(names[i++], "[-A-]");
  strcpy(names[i++], "[-C-]");
  strcpy(names[i++], "[-D-]");
  strcpy(names[i++], "[-E-]");
  strcpy(names[i++], "[-G-]");
  
  // Get directory names
  memset(&fInfo, 0, sizeof(struct _find_t));
  if(_dos_findfirst("*.*", _A_SUBDIR, &fInfo) == 0)
  {
    if(fInfo.attrib & _A_SUBDIR && stricmp(".", fInfo.name))
    {
      sprintf(names[i], "[%s]", fInfo.name);
      i++;
    }
  }
  while(_dos_findnext(&fInfo) == 0)
  {
    if(fInfo.attrib & _A_SUBDIR && stricmp(".", fInfo.name))
    {
      sprintf(names[i], "[%s]", fInfo.name);
      i++;
    }
  }
  
  // Get all the file names
  cp = extensions;
  while(*cp != '&')
  {
    j = 0;
    if(*cp == ';')
    {
      cp++;
    }
    while(*cp != ';' && *cp != '&')
    {
      findExt[j++] = *cp++;
    }
    findExt[j] = 0;
        
    memset(&fInfo, 0, sizeof(struct _find_t));
    if(_dos_findfirst(findExt, _A_NORMAL | _A_RDONLY, &fInfo) == 0)
    {
      strcpy(names[i], fInfo.name);
      i++;
    }
    while(_dos_findnext(&fInfo) == 0)
    {
      strcpy(names[i], fInfo.name);
      i++;
    }
  }
  
  maxOffset = i - 25;
  curY = 0;
  yOffset = 0;
  
  ClearScreen(WHITE, BLACK);
  Cursor(0, 0);
  
  while(subloop)
  {
    Cursor(0, 0);
    RepeatChar(' ', 80, YELLOW, BLUE);
    WriteString(YELLOW, BLUE, 1, 0, "[ESC] to cancel   [ENTER] to select");
                
    
    // print filenames
    for(cnt = 0; cnt < 24; cnt++)
    {
      if((cnt+yOffset) < i)
      {
        printf("\n    %-15s", names[cnt+yOffset]);
      }
    }
    // print marker
    WriteString(RED, BLACK, 0, curY+1, "-->");
    
    key = GetKey(WAIT);
    
    if(LOBYTE(key) == 27) // Cancel
    {
      CursorOn();
      return "";
    } else if(LOBYTE(key) == 13) // Enter
    { 
      if(names[curY+yOffset][0] == '[' &&
         names[curY+yOffset][1] == '-' &&
         names[curY+yOffset][3] == '-' &&
         names[curY+yOffset][4] == ']')
      {
        if(_chdrive(names[curY+yOffset][2] - 'A' + 1) == 0)
        {
          goto Top;
        } else
        {
          MessageBox("That is an invalid drive!");
          CursorOff();
        }
      } else if(names[curY+yOffset][0] == '[')
      {
        sscanf(names[curY+yOffset], "[%s]", backup);
        cp = strchr(backup, ']');
        if(cp)
        {
          *cp = 0;
        }
        _chdir(backup);
        goto Top;
      } else
      {
        subloop = 0;
      }
    } else if(LOBYTE(key) == 0xE0 || LOBYTE(key) == 0x00)
    {
      if(HIBYTE(key) == 72) // up arrow
      {
        if(curY > 0)
        {
          curY--;
        } else if(curY == 0)
        {
          if(yOffset > 0)
          {
            yOffset--;
          }
        }
      } else if(HIBYTE(key) == 80) // down arrow
      {
        if(curY < 23 && curY < (i-yOffset-1))
        {
          curY++;
        } else if(curY == 23)
        {
          if(yOffset <= maxOffset)
          {
            yOffset++;
          }
        }
      }
    }
  }
  
  strcpy(backup, names[curY+yOffset]);
  CursorOn();
  return backup;
}


short WriteRecord(FILE *fp, short num)
{
  short i;
  char c;
  unsigned char uc;
  short s;
  unsigned short us;
  long l;
  unsigned long ul;
  double d;
  
  fseek(fp, 8L + (numFields * 4L) + (recordLength * num), SEEK_SET);
  
  for(i = 0; i < numFields; i++)
  {
    switch(fieldInfo[i][F_TYPE])
    {
      case STRING:  if(fwrite(fieldData[i], sizeof(char),
                       fieldInfo[i][F_LENGTH] + 1, fp) != 
                       (unsigned short)fieldInfo[i][F_LENGTH] + 1)
                    {
                      MessageBox("Error writing to disk!");
                      return FALSE;
                    }
                    break;
      case CHARACTER: c = StrToChar(fieldData[i]);
                      if(fwrite(&c, sizeof(char), 1, fp) != 1)
                      {
                        MessageBox("Error writing to disk!");
                        return FALSE;
                      }
                      break;
      case UNSIGNED_CHARACTER: uc = StrToUnChar(fieldData[i]);
                               if(fwrite(&uc, sizeof(char), 1, fp) != 1)
                               {
                                 MessageBox("Error writing to disk!");
                                 return FALSE;
                               }
                               break; 
      case INTEGER: s = StrToInt(fieldData[i]);
                    if(fwrite(&s, sizeof(short), 1, fp) != 1)
                    {
                      MessageBox("Error writing to disk!");
                      return FALSE;
                    }
                    break;
      case UNSIGNED_INTEGER: us = StrToUnInt(fieldData[i]);
                             if(fwrite(&us, sizeof(short), 1, fp) != 1)
                             {
                               MessageBox("Error writing to disk!");
                               return FALSE;
                             }
                             break;
      case LONG: l = StrToLong(fieldData[i]);
                 if(fwrite(&l, sizeof(long), 1, fp) != 1)
                 {
                   MessageBox("Error writing to disk!");
                   return FALSE;
                 }
                 break;
      case UNSIGNED_LONG: ul = StrToLong(fieldData[i]);
                          if(fwrite(&ul, sizeof(long), 1, fp) != 1)
                          {
                            MessageBox("Error writing to disk!");
                            return FALSE;
                          }
                          break;
      case DOUBLE: d = StrToDouble(fieldData[i]);
                   if(fwrite(&d, sizeof(double), 1, fp) != 1)
                   {
                     MessageBox("Error writing to disk!");
                     return FALSE;
                   }
                   break;
    }
  }
  
  return TRUE;
} 


short ReadRecord(FILE *fp, short num)
{
  short i;
  char c;
  unsigned char uc;
  short s;
  unsigned short us;
  long l;
  unsigned long ul;
  double d;
  
  fseek(fp, 8L + (numFields * 4L) + (recordLength * num), SEEK_SET);
  
  for(i = 0; i < numFields; i++)
  {
    switch(fieldInfo[i][F_TYPE])
    {
      case STRING:  if(fread(fieldData[i], sizeof(char),
                       fieldInfo[i][F_LENGTH] + 1, fp) != 
                       (unsigned short)fieldInfo[i][F_LENGTH] + 1)
                    {
                      MessageBox("Error reading from disk!");
                      return FALSE;
                    }
                    break;
      case CHARACTER: if(fread(&c, sizeof(char), 1, fp) != 1)
                      {
                        MessageBox("Error reading from disk!");
                        return FALSE;
                      }
                      sprintf(fieldData[i], "%d", c);
                      break;
      case UNSIGNED_CHARACTER: if(fread(&uc, sizeof(char), 1, fp) != 1)
                               {
                                 MessageBox("Error reading from disk!");
                                 return FALSE;
                               }
                               sprintf(fieldData[i], "%d", uc);
                               break; 
      case INTEGER: if(fread(&s, sizeof(short), 1, fp) != 1)
                    {
                      MessageBox("Error reading from disk!");
                      return FALSE;
                    }
                    sprintf(fieldData[i], "%d", s);
                    break;
      case UNSIGNED_INTEGER: if(fread(&us, sizeof(short), 1, fp) != 1)
                             {
                               MessageBox("Error reading from disk!");
                               return FALSE;
                             }
                             sprintf(fieldData[i], "%u", us);
                             break;
      case LONG: if(fread(&l, sizeof(long), 1, fp) != 1)
                 {
                   MessageBox("Error reading from disk!");
                   return FALSE;
                 }
                 sprintf(fieldData[i], "%ld", l);
                 break;
      case UNSIGNED_LONG: if(fread(&ul, sizeof(long), 1, fp) != 1)
                          {
                            MessageBox("Error reading from disk!");
                            return FALSE;
                          }
                          sprintf(fieldData[i], "%lu", ul);
                          break;
      case DOUBLE: if(fread(&d, sizeof(double), 1, fp) != 1)
                   {
                     MessageBox("Error reading from disk!");
                     return FALSE;
                   }
                   sprintf(fieldData[i], "%f", d);
                   break;
    }
  }
  
  return TRUE;
}


short OpenNewFile(char *fname)
{
  short i;
  short ver;
  
  dfile = fopen(fname, "w+b");
  if(!dfile)
  {
    MessageBox("Unable to create file %s.", fname);
    return FALSE;
  }
  
  ver = FILE_VERSION;
  if(fwrite(&ver, sizeof(short), 1, dfile) != 1)
  {
    MessageBox("Error writing to disk!");
    return FALSE;
  }
  
  numRecords = 1;
  if(fwrite(&numRecords, sizeof(short), 1, dfile) != 1)
  {
    MessageBox("Error writing to disk!");
    return FALSE;
  }
  
  if(fwrite(&recordLength, sizeof(short), 1, dfile) != 1)
  {
    MessageBox("Error writing to disk!");
    return FALSE;
  }
  
  if(fwrite(&numFields, sizeof(short), 1, dfile) != 1)
  {
    MessageBox("Error writing to disk!");
    return FALSE;
  }
  
  for(i = 0; i < numFields; i++)
  {
    if(fwrite(&fieldInfo[i][F_TYPE], sizeof(short), 1, dfile) != 1)
    {
      MessageBox("Error writing to disk!");
      return FALSE;
    }
    if(fwrite(&fieldInfo[i][F_LENGTH], sizeof(short), 1, dfile) != 1)
    {
      MessageBox("Error writing to disk!");
      return FALSE;
    }
    if(fwrite(&fieldNames[i], sizeof(char), 21, dfile) != 21)
    {
      MessageBox("Error writing to disk!");
      return FALSE;
    }
  }
  
  WriteRecord(dfile, 1);
  
  return TRUE;
}


short OpenOldFile(char *fname)
{
  short i;
  short ver;
  
  dfile = fopen(fname, "r+b");
  if(!dfile)
  {
    MessageBox("Unable to open file %s.", fname);
    return FALSE;
  }
  
  if(fread(&ver, sizeof(short), 1, dfile) != 1)
  {
    MessageBox("Error reading from disk!");
    return FALSE;
  }
  
  if(ver != FILE_VERSION)
  {
    MessageBox("%s is a version #%d file. Can't read it.", filename, ver);
    return FALSE;
  }
  
  if(fread(&numRecords, sizeof(short), 1, dfile) != 1)
  {
    MessageBox("Error reading from disk!");
    return FALSE;
  }
  
  if(fread(&recordLength, sizeof(short), 1, dfile) != 1)
  {
    MessageBox("Error reading from disk!");
    return FALSE;
  }
  
  if(fread(&numFields, sizeof(short), 1, dfile) != 1)
  {
    MessageBox("Error reading from disk!");
    return FALSE;
  }
  
  for(i = 0; i < numFields; i++)
  {
    if(fread(&fieldInfo[i][F_TYPE], sizeof(short), 1, dfile) != 1)
    {
      MessageBox("Error reading from disk!");
      return FALSE;
    }
    if(fread(&fieldInfo[i][F_LENGTH], sizeof(short), 1, dfile) != 1)
    {
      MessageBox("Error reading from disk!");
      return FALSE;
    }
    if(fread(&fieldNames[i], sizeof(char), 21, dfile) != 21)
    {
      MessageBox("Error reading from disk!");
      return FALSE;
    }
  }
  
  ReadRecord(dfile, 1);
  
  return TRUE;
}


short FileExist(char *fname)
{
  FILE *fp;
  
  fp = fopen(fname, "rb");
  if(!fp)
  {
    return FALSE;
  } else
  {
    fclose(fp);
    return TRUE;
  }
}


void CloseFile(FILE *fp)
{
  fclose(fp);
}