#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <conio.h>

#include "main.h"
#include "menus.h"
#include "files.h"
#include "edit.h"
#include "textgrph.h"
#include "help.h"


short YesNoBox(char *message, ...)
{
  char *screenBuffer;
  short done = FALSE;
  char temp[120];
  va_list args;
  short key;
  short x1, x2;
  short ret;
  
  va_start(args, message);
  vsprintf(temp, message, args);
  va_end(args);
  
  x1 = 40 - ((strlen(temp) + 10) / 2);
  x2 = 40 + ((strlen(temp) + 10) / 2);
  
  screenBuffer = SaveScreenArea(x1, 10, x2+2, 15);
  if(screenBuffer == NULL)
  {
    // Not enough memory!!!!!!
  }
  
  CursorOff();
  Grid(x1+2, 11, x2+2, 15, GRAY, BLACK, 1);
  Box(x1, 10, x2, 14, DOUBLE_BOX, 1, BLACK, WHITE);
  
  WriteString(BLACK, WHITE, x1+2, 12, "%s [Y/N]", temp);
  
  while(!done)
  {
    key = GetKey(WAIT);
    
    if(LOBYTE(key) == 'y' || LOBYTE(key) == 'Y')
    {
      done = 1;
      ret = TRUE;
    } else if(LOBYTE(key) == 'n' || LOBYTE(key) == 'N')
    {
      done = 1;
      ret = FALSE;
    } else
    {
      Boop();
    }
  }
  
  RestoreScreenArea(screenBuffer);
  CursorOn();
  return ret;
}


void MessageBox(char *message, ...)
{
  char *screenBuffer;
  char temp[120];
  va_list args;
  short x1, x2;

  va_start(args, message);
  vsprintf(temp, message, args);
  va_end(args);
  
  x1 = 40 - ((strlen(message) + 4) / 2);
  x2 = 40 + ((strlen(message) + 4) / 2);
  
  screenBuffer = SaveScreenArea(x1, 10, x2+2, 15);
  if(screenBuffer == NULL)
  {
    // Not enough memory!!!!!!
  }
  
  CursorOff();
  Grid(x1+2, 11, x2+2, 15, GRAY, BLACK, 1);
  Box(x1, 10, x2, 14, DOUBLE_BOX, 1, BLACK, WHITE);
  
  WriteString(BLACK, WHITE, x1+2, 12, "%s", temp);
  
  GetKey(WAIT);
  
  RestoreScreenArea(screenBuffer);
  CursorOn();
} 


short DoActionBar(void)
{
  char *fileMenu[] = {"Save           F2", "Main Menu     ESC",
                      "DOS Shell        ", "Exit             "};
  short fileRet[] = {1, 2, 3, 4};
  
  char *editMenu[] = {"Clear Field     ","Clear Record    ",
                      "Search        F3"};
  short editRet[] = {10, 11, 12};
  
  char *recordMenu[] = {"New Record          F4","Delete Record         ",
                        "Next Record       PGUP","Previous Record   PGDN"};
  short recordRet[] = {20, 21, 22, 23};
  
  char *reportMenu[] = {"Create Report   "};
  short reportRet[] = {30};
                        
  char *helpMenu[] = {"Main Help     F1", "About           "};
  short helpRet[] = {40, 41};                      

  short rv = -3;
  short curMen = 0;
  short done = FALSE;
  
  CursorOff();  
  while(!done)
  {
    switch(curMen)
    {
      case 0:  /* file menu */
               rv = DropMenu(1, 1, " File ", 3, 0, 4, fileRet, fileMenu);
               break;
      case 1:  /* edit menu */
               rv = DropMenu(8, 1, " Edit ", 10, 0, 3, editRet, editMenu);
               break;
      case 2:  /* record menu */
               rv = DropMenu(15, 1, " Record ", 17,0,4,recordRet,recordMenu);
               break;
      case 3:  /* report menu */
               rv = DropMenu(24, 1, " Report ", 26,0,1,reportRet,reportMenu);
               break;
      case 4:  /* help menu */
               rv = DropMenu(33, 1, " Help ", 35, 0, 2, helpRet, helpMenu);
               break;
    }
    
    switch(rv)
    {
      case -2:  /* left */
                curMen--;
                if(curMen < 0)
                {
                  curMen = 4;
                }
                break;
      case -1:  /* right */
                curMen++;
                if(curMen > 4)
                {
                  curMen = 0;
                }
                break;
      default:  done = TRUE;
                break;
    }
  }
  CursorOn();
  return rv;
} 

short DropMenu(short x, short y, char *title, short tx, short ty, short num,
               short ret[], char *choices[])
{
  short rv = 0;
  char *screenBuffer;
  short len = 0;
  short i;
  short yPos = 0;
  short done = 0;
  short key;
  
  for(i = 0; i < num; i++)
  {
    if(len < (short)strlen(choices[i]))
    {
      len = strlen(choices[i]);
    }
  }
  
  screenBuffer = SaveScreenArea(x - 1, y - 1, x + len + 6, y + 3 + num);
  
  WriteString(WHITE, BLACK, tx, ty, "%s", title);
  Grid(x+2, y+1, x+len+5, y+2+num, GRAY, BLACK, 1);
  Box(x, y, x+len+3, y+num+1, SINGLE_BOX, 1, BLACK, WHITE);
  
  while(!done)
  {
    for(i = 0; i < num; i++)
    {
      WriteString(BLACK, WHITE, x+1, i+y+1, " %s ", choices[i]);
    }
    /* print selected choice */
    WriteString(WHITE, BLACK, x+1, yPos+y+1, " %s ", choices[yPos]);
    
    key = GetKey(WAIT);
    
    if(LOBYTE(key) == 13)  /* enter key */
    {
      done = TRUE;
      rv = ret[yPos];
    } else if(LOBYTE(key) == 27) /* esc key */
    {
      done = TRUE;
      rv = -3;
    } else if(LOBYTE(key) == 0x00 || LOBYTE(key) == 0xE0)
    {
      if(HIBYTE(key) == 72) /* Up arrow */
      {
        yPos--;
        if(yPos < 0)
        {
          yPos = (num - 1);
        }
      } else if(HIBYTE(key) == 80) /* down arrow */
      {
        yPos++;
        if(yPos > (num - 1))
        {
          yPos = 0;
        }
      } else if(HIBYTE(key) == 75) /* left arrow */
      {
        rv = -2;
        done = TRUE;
      } else if(HIBYTE(key) == 77) /* right arrow */
      {
        rv = -1;
        done = TRUE;
      }
    }  
  }
  
  RestoreScreenArea(screenBuffer);
  return rv;
}


