#ifndef _TEXTGRPH_H
#define _TEXTGRPH_H

#define DOUBLE_BOX   1
#define SINGLE_BOX   2
#define BLANK_BOX    3

#define BLACK         0
#define BLUE          1
#define GREEN         2
#define CYAN          3
#define RED           4
#define MAGENTA       5
#define BROWN         6
#define WHITE         7
#define GRAY          8
#define LIGHTBLUE     9
#define LIGHTGREEN   10
#define LIGHTCYAN    11
#define LIGHTRED     12
#define LIGHTMAGENTA 13
#define YELLOW       14
#define BRIGHTWHITE  15

#define SCROLL_UP   0x07
#define SCROLL_DOWN 0x06

#define HIBYTE(x)   ((unsigned char)(x >> 8))
#define LOBYTE(x)   ((unsigned char)(x & 0xFF))

#define WAIT    1
#define NOWAIT  0


unsigned long GetTimerTicks(void);
void WaitSecond(double seconds);
short GetKey(short wait);
void ClearKeyBuffer(void);
void Cursor(short x, short y);
void SetCursorSize(short start, short end);
void GetCursor(short *x, short *y, short *page, short *start, short *end);
void GetVideo(short *columns, short *displayMode, short *displayPage);
void SetVideo(short displayMode);
void SetBorderColor(short color);
void WriteChar(char ch, short fcolor, short bcolor);
void RepeatChar(char ch, short howMany, short fcolor, short bcolor);
void WriteString(short fcolor, short bcolor, short x, short y, char *string, ...);
void Box(short x0, short y0, short x1, short y1, short type,
         short fill, short fcolor, short bcolor);
void Scroll(short x, short y, short width, short height, short nbr, short direction);
void CursorOff(void);
void CursorOn(void);
void ClearScreen(short fcolor, short bcolor);
void Grid(short x0, short y0, short x1, short y1, short fcolor, short bcolor, short type);
char *SaveScreenArea(short x0, short y0, short x1, short y1);
void RestoreScreenArea(char *buffer);



#endif // _TEXTGRPH_H
 